/*
 *  $Id: attr_putval.c,v 1.6 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

#ifndef MPIR_TRUE
#define MPIR_TRUE  1
#define MPIR_FALSE 0
#endif

/*@

MPI_Put_attr - stores attribute value associated with a key

@*/
int MPI_Put_attr ( comm, keyval, attr_value )
MPI_Comm comm;
int keyval;
void *attr_value;
{
  MPIR_HBT_node *attr;
  MPIR_Attr_key *attr_key = (MPIR_Attr_key *)keyval;

  if ( comm != (MPI_Comm)0 ) {
    MPIR_HBT_lookup(comm->attr_cache, keyval, &attr);
    if (attr == (MPIR_HBT_node *)0) {
      (void) MPIR_HBT_new_node ( keyval, attr_value, &attr );
      (void) MPIR_HBT_insert ( comm->attr_cache, attr );
    }
    else {
      if ( attr_key->delete_fn != (int(*)())0 )
        (void) attr_key->delete_fn( comm, keyval, attr_key->extra_state );
      attr->value = attr_value;
    }
  }
  return (MPI_SUCCESS);
}
