/*
 *  $Id: send.c,v 1.6 1993/12/03 20:46:49 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: send.c,v 1.6 1993/12/03 20:46:49 lusk Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Send - Basic send
@*/
int MPI_Send( start, count, datatype, dest, tag, comm )
void             *start;
int              count;
MPI_Datatype     datatype;
int              dest;
int              tag;
MPI_Comm comm;
{
    MPI_Comm_request handle;
    MPI_Status       status;

    if (dest != MPI_PROCNULL)
    {
	MPI_Isend( start, count, datatype, dest, tag, comm, &handle );
	MPI_Wait( &handle, &status );
    }
    return MPI_OK;
}
